<?php

     $className = "ubrir";
     $paymentName = "Платежный модуль УБРиР";

     include "../standalone.php";

     $objectTypesCollection = umiObjectTypesCollection::getInstance();
     $objectsCollection = umiObjectsCollection::getInstance();

     // получаем родительский тип
     $parentTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-payment");

     // Тип для внутреннего объекта, связанного с публичным типом
     $internalTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-paymenttype");
     $typeId = $objectTypesCollection->addType($parentTypeId, $paymentName);

    // Создаем внутренний объект
     $internalObjectId = $objectsCollection->addObject($paymentName, $internalTypeId);
     $internalObject = $objectsCollection->getObject($internalObjectId);
     $internalObject->setValue("class_name", $className); // имя класса для реализации

     // связываем его с типом
     $internalObject->setValue("payment_type_id", $typeId);
     $internalObject->setValue("payment_type_guid", "user-emarket-payment-" . $typeId);
     $internalObject->commit();

     // Связываем внешний тип и внутренний объект
     $type = $objectTypesCollection->getType($typeId);
     $type->setGUID($internalObject->getValue("payment_type_guid"));
     $type->commit();

    // создаем группу полей "Параметры" и добавляем поля
     $protocol = 'https://';

    if ($_SERVER['HTTPS'] == null) {
        $protocol = 'http://';
    }
    $host = $_SERVER['HTTP_HOST'];
    $pathUbrirSettings = $protocol . $host . '/ubrr/orders/index.php';
    $settingsPath = $protocol . $host . '/admin/emarket/payment/';

    $fieldsCollection = umiFieldsCollection::getInstance();
    $fieldId = $fieldsCollection->addField('mnt_ubrir_id', 'ID интернет-магазина', 8); // ID интернет-магазина
    $fieldUbrirId = $fieldsCollection->getField($fieldId);

    $fieldUbrirId->setIsRequired(true);

    $fieldPass = $fieldsCollection->addField('mnt_secret_key', 'Пароль к сертификату', 16); // Пароль к сертификату
    $fieldUbrirPass = $fieldsCollection->getField($fieldPass);
    $fieldUbrirPass->setIsRequired(true);

    $type  = umiObjectTypesCollection::getInstance()->getType($typeId);
    if($type) {
            $type->addFieldsGroup('settings', 'Параметры', true, true);
            $group = $type->getFieldsGroupByName('settings');
            $group->setTip('Для того, чтобы посмотреть статус у заказа, сверку или выписку - перейдите по ' . $pathUbrirSettings);
            $group->attachField($fieldId);
            $group->attachField($fieldPass);
    }

    $config = mainConfiguration::getInstance();
    $host = $config->get('connections', 'core.host');
    $login = $config->get('connections', 'core.login');
    $password = $config->get('connections', 'core.password');
    $dbname = $config->get('connections', 'core.dbname');
    $mysqli = new mysqli($host, $login, $password, $dbname);
    $mysqli->set_charset("utf8");

    $sql = "CREATE TABLE IF NOT EXISTS `umi_twpg` (
   `id` INT  AUTO_INCREMENT  NOT NULL,
   `umi_id` VARCHAR (255)  NOT NULL,
   `twpg_id`  VARCHAR (255)  NOT NULL,
   `session_id`  VARCHAR (255) ,
   PRIMARY KEY (`id`)
);
";
$mysqli->multi_query($sql);
    function copyDir( $source, $destination ) {
        if ( is_dir( $source ) ) {
            @mkdir( $destination, 0755 );
            $directory = dir( $source );
            while ( FALSE !== ( $readdirectory = $directory->read() ) ) {
                if ( $readdirectory == '.' || $readdirectory == '..' ) continue;
                $PathDir = $source . '/' . $readdirectory; 
                if ( is_dir( $PathDir ) ) {
                        copyDir( $PathDir, $destination . '/' . $readdirectory );
                    continue;
                }
            copy( $PathDir, $destination . '/' . $readdirectory );
            }
            $directory->close();
        } else {
            copy( $source, $destination );
        }
    } 

    $tmpls = scandir ('../templates');
    foreach($tmpls as $tmpp) {
        if($tmpp != '.' AND $tmpp != '..') {
        @copy( dirname(__FILE__)."/ubrir.phtml", $_SERVER['DOCUMENT_ROOT']."/templates/".$tmpp."/php/emarket/payment/ubrir.phtml");
        }
    }
    

    $destination = $_SERVER['DOCUMENT_ROOT'].'/classes/components/emarket/classes/payment/systems/';
    @copyDir( dirname(__FILE__)."/ubrir_files", $destination."/ubrir_files");
    copy( dirname(__FILE__)."/ubrir.php", $destination."/ubrir.php" );

    echo "<p>Установка модуля прошла успешно</p>";
    echo "<p>Перейдите в <a href='".$settingsPath."'>административную панель</a>, чтобы настроить систему.</p>";
    echo "<p>Для просмотра информации о заказах перейдите по ссылке <a href='".$pathUbrirSettings."'>". $pathUbrirSettings ."</a>.</p>";

?>
